#!/usr/bin/perl

%h = (
	'....', 0,
	'...#', 1,
	'..#.', 2,
	'..##', 3,
	'.#..', 4,
	'.#.#', 5,
	'.##.', 6,
	'.###', 7,
	'#...', 8,
	'#..#', 9,
	'#.#.', a,
	'#.##', b,
	'##..', c,
	'##.#', d,
	'###.', e,
	'####', f,
);

@bytes = ();
@width = ();
$width = -1;
$code = 31;
$line = 0;
$bcnt = 0;

$name = $ARGV[0];
open(FILE, $name) || die "Can't open file $name";

while (<FILE>) {
	chop;
	$line++;
	s/\r//go;
	next unless $_;
	if ( /^code/o ) {
		if ( $width >= 0 ) {
			die "Wrong font height before line $line\n" if $bcnt != 8;
			$width = 2 if $code == 32;
			$width++;
			push(@width, sprintf("%02x", $width));
			$code++;
			$width = 0;
			$bcnt = 0;
		}
	}
	elsif ( $_ =~ /^([.#]{4})([.#]{4})/o ) {
		$w = rindex($_, '#');
		$width = $w if $w > $width;
		push(@bytes, ($h{$1}.$h{$2}));
		$bcnt++;
	}
	else {
		die "Wrong data in line $line '$_'\n";
	}
}
if ( $width >= 0 ) {
	die "Wrong font height before line $line\n" if $bcnt != 8;
	$width = 2 if $code == 32;
	$width++;
	push(@width, sprintf("%02x", $width));
}

($fname) = split('\.', $name);

open(FILE, "> $fname.fnt") || die $!;
binmode FILE;
print FILE pack('H*', '08');
print FILE pack('H*', join('', @width));
print FILE pack('H*', join('', @bytes));
print "Font $fname.fnt created\n";
